/*-------Header: Lestat-------*/

/* Las primeras 3 declaraciones son opcionales */


/* Activar extensiones GNU */
//#define GNUEXT

/* Activa el despliegamento del texto analizado (util solo en pruebas) */
//#define DESP_TXT


/* Activa el procesamiento de caracteres europeos (util para la mayoria de nosotros) */
#define ISO_8859_1


/* Estructura donde se almacena la informacion estadistica */

typedef struct {
  char ltr;       // Caracter/letra
  unsigned long num; // Numero
  float frec; // Frecuencia (porcentaje)
} record_t;


/* Abrir archivo */

FILE* openfile (char archivo[], char modo[]);



/* Definir Alfabeto */

#ifdef ISO_8859_1
  char alpha[]="ABCDEFGHIJKLMNOPQRSTUVWXYZ";  // Caracteres base

#else
  char alpha[]="ABCDEFGHIJKLMNOPQRSTUVWXYZ";

#endif



/* Procesamientamiento de characteres ASCII estandar */

#ifdef GNUEXT
void stdchar (FILE*, char*, char) __attribute__ ((noreturn));

#else
void stdchar (FILE*, char*, char);

#endif



/* Procesamiento de characteres ASCII y europeos (, , , , , ) */

#ifdef GNUEXT
void eurochar (FILE*, char*, char) __attribute__ ((noreturn)); 

#else
void eurochar (FILE*, char*, char);

#endif



/* Contador de caracteres */

int alphacount (char*, char*);



/* Descriptor de uso */

#ifdef GNUEXT
void uso (char*) __attribute__ ((noreturn));

#else
void uso (char*);

#endif



/*-------Funciones-------*/

FILE* openfile (char archivo[], char modo[]) {

  FILE* fp;

  if ( (fp=fopen(archivo, modo)) == '\0') {
    printf("fopen: El archivo \"%s\" no existe.\n", archivo);
    exit (EXIT_FAILURE);
  }

  return fp;

}



void stdchar (FILE* fp, char* buff, char fc) {

  int i=0;

  while( (fc=getc(fp)) != EOF ) {
      buff[i++] = toupper(fc);
  }

  buff[i] = '\0';

}



void eurochar (FILE* fp, char* buff, char fc) {

  int i=0;

  while( (fc=getc(fp)) != EOF ) {

    switch(fc) {
    case '':
      buff[i++] = '';
      continue;
    case '':
      buff[i++] = 'A';
      continue;
    case '':
      buff[i++] = 'E';
      continue;
    case '':
      buff[i++] = 'I';
      continue;
    case '':
      buff[i++] = 'O';
      continue;
    case '':
      buff[i++] = 'U';
      continue;
    case '':
      buff[i++] = 'A';
      continue;
    case '':
      buff[i++] = 'E';
      continue;
    case '':
      buff[i++] = 'I';
      continue;
    case '':
      buff[i++] = 'O';
      continue;
    case '':
      buff[i++] = 'U';
      continue;

    default :
      buff[i++] = toupper(fc);
    }

  }

  buff[i] = '\0';

}



int alphacount (char* buff, char* ap)
{

  int ac = 0;

    do {

      buff = strstr(buff, ap);
      if (buff != '\0') {
	ac++;
	buff++;
      }

    } while (buff != '\0');

    return ac;

}



void uso (char* n) {

  printf("\nUso:\t%s  -t | -b  archivo_entrada [archivo_salida]\n\nEl archivo de salida sera binario\n\nOpciones:\n-t:\tProcesar archivo de texto\n-b:\tProcesar archivo binario generado por LeStat\n\n", n);
  
}


