#!/bin/sh
# the next line restarts using wish\
exec wish "$0" "$@" 

package require solitaire
namespace import ::solitaire::*
::solitaire::init "0-9" "A-Z" "a-z" " \t\n\r!?.,_-'=;:" 

if {![info exists vTcl(sourcing)]} {
    switch $tcl_platform(platform) {
	windows {
	}
	default {
	    option add *Scrollbar.width 10
	}
    }
    
}


############################
# vTcl Code to Load Stock Images


if {![info exist vTcl(sourcing)]} {
proc vTcl:rename {name} {
    regsub -all "\\." $name "_" ret
    regsub -all "\\-" $ret "_" ret
    regsub -all " " $ret "_" ret
    regsub -all "/" $ret "__" ret
    regsub -all "::" $ret "__" ret

    return [string tolower $ret]
}

proc vTcl:image:create_new_image {filename description type data} {
    global vTcl env

    # Does the image already exist?
    if {[info exists vTcl(images,files)]} {
        if {[lsearch -exact $vTcl(images,files) $filename] > -1} { return }
    }

    if {![info exists vTcl(sourcing)] && [string length $data] > 0} {
        set object [image create  [vTcl:image:get_creation_type $filename]  -data $data]
    } else {
        # Wait a minute... Does the file actually exist?
        if {! [file exists $filename] } {
            # Try current directory
            set script [file dirname [info script]]
            set filename [file join $script [file tail $filename] ]
        }

        if {![file exists $filename]} {
            set description "file not found!"
            set object [image create photo -data [vTcl:image:broken_image] ]
        } else {
            set object [image create  [vTcl:image:get_creation_type $filename]  -file $filename]
        }
    }

    set reference [vTcl:rename $filename]

    set vTcl(images,$reference,image)       $object
    set vTcl(images,$reference,description) $description
    set vTcl(images,$reference,type)        $type
    set vTcl(images,filename,$object)       $filename

    lappend vTcl(images,files) $filename
    lappend vTcl(images,$type) $object

    # return image name in case caller might want it
    return $object
}

proc vTcl:image:get_image {filename} {
    global vTcl
    set reference [vTcl:rename $filename]

    # Let's do some checking first
    if {![info exists vTcl(images,$reference,image)]} {
        # Well, the path may be wrong; in that case check
        # only the filename instead, without the path.

        set imageTail [file tail $filename]

        foreach oneFile $vTcl(images,files) {
            if {[file tail $oneFile] == $imageTail} {
                set reference [vTcl:rename $oneFile]
                break
            }
        }
    }
    return $vTcl(images,$reference,image)
}

proc vTcl:image:get_creation_type {filename} {
    set ext [file extension $filename]
    set ext [string tolower $ext]

    switch $ext {
        .ppm -
        .gif    {return photo}
        .xbm    {return bitmap}
        default {return photo}
    }
}

proc vTcl:image:broken_image {} {
    return {
        R0lGODdhFAAUAPcAAAAAAIAAAACAAICAAAAAgIAAgACAgMDAwICAgP8AAAD/
        AP//AAAA//8A/wD//////wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
        AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
        AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
        AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
        AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
        AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
        AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
        AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
        AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
        AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
        AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
        AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
        AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
        AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
        AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
        AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
        AAAAAAAAAAAAAAAAAAAAACwAAAAAFAAUAAAIhAAPCBxIsKDBgwgPAljIUOBC
        BAkBPJg4UeBEBBAVPkCI4EHGghIHChAwsKNHgyEPCFBA0mFDkBtVjiz4AADK
        mAds0tRJMCVBBkAl8hwYMsFPBwyE3jzQwKhAoASUwmTagCjDmksbVDWIderC
        g1174gQ71CHFigfOhrXKUGfbrwnjyp0bEAA7
    }
}

foreach img {


            } {
    eval set _file [lindex $img 0]
    vTcl:image:create_new_image\
        $_file [lindex $img 1] [lindex $img 2] [lindex $img 3]
}

}
############################
# vTcl Code to Load User Images

foreach img {

        {{[file join C:/ {My Documents} alizee alizee graf navegador.gif]} {user image} user {}}
        {{[file join C:/ {My Documents} alizee alizee graf correo.gif]} {user image} user {}}
        {{[file join C:/ {My Documents} alizee alizee graf mensajero.gif]} {user image} user {}}
        {{[file join C:/ {My Documents} alizee alizee graf encripcion.gif]} {user image} user {}}
        {{[file join C:/ {My Documents} alizee alizee graf desencripcion.gif]} {user image} user {}}
        {{[file join C:/ {My Documents} alizee alizee graf configuracion.gif]} {user image} user {}}
        {{[file join C:/ {My Documents} alizee alizee graf ayuda.gif]} {user image} user {}}
        {{[file join C:/ {My Documents} alizee alizee graf acerca.gif]} {user image} user {}}

            } {
    eval set _file [lindex $img 0]
    vTcl:image:create_new_image\
        $_file [lindex $img 1] [lindex $img 2] [lindex $img 3]
}

############################
# vTcl Code to Load Stock Fonts


if {![info exist vTcl(sourcing)]} {
set vTcl(fonts,counter) 0
proc vTcl:font:add_font {font_descr font_type newkey} {
     global vTcl

     incr vTcl(fonts,counter)
     set newfont [eval font create $font_descr]

     lappend vTcl(fonts,objects) $newfont

     # each font has its unique key so that when a project is
     # reloaded, the key is used to find the font description

     if {$newkey == ""} {
          set newkey vTcl:font$vTcl(fonts,counter)

          # let's find an unused font key
          while {[vTcl:font:get_font $newkey] != ""} {
             incr vTcl(fonts,counter)
             set newkey vTcl:font$vTcl(fonts,counter)
          }
     }

     set vTcl(fonts,$newfont,type)                      $font_type
     set vTcl(fonts,$newfont,key)                       $newkey
     set vTcl(fonts,$vTcl(fonts,$newfont,key),object)   $newfont

     lappend vTcl(fonts,$font_type) $newfont

     # in case caller needs it
     return $newfont
}

proc vTcl:font:get_font {key} {
    global vTcl
    if {[info exists vTcl(fonts,$key,object)]} then {
        return $vTcl(fonts,$key,object)
    } else {
        return ""
    }
}

}
############################
# vTcl Code to Load User Fonts

vTcl:font:add_font \
    "-family {AvantGarde Bk BT} -size 10 -weight normal -slant roman -underline 0 -overstrike 0" \
    user \
    vTcl:font10
#############################################################################
# Visual Tcl v1.51 Project
#

#################################
# VTCL LIBRARY PROCEDURES
#

if {![info exists vTcl(sourcing)]} {
proc Window {args} {
    global vTcl
    set cmd     [lindex $args 0]
    set name    [lindex $args 1]
    set newname [lindex $args 2]
    set rest    [lrange $args 3 end]
    if {$name == "" || $cmd == ""} { return }
    if {$newname == ""} { set newname $name }
    if {$name == "."} { wm withdraw $name; return }
    set exists [winfo exists $newname]
    switch $cmd {
        show {
            if {$exists} {
                wm deiconify $newname
            } elseif {[info procs vTclWindow$name] != ""} {
                eval "vTclWindow$name $newname $rest"
            }
            if {[wm state $newname] == "normal"} {
                vTcl:FireEvent $newname <<Show>>
            }
        }
        hide    {
            if {$exists} {
                wm withdraw $newname
                vTcl:FireEvent $newname <<Hide>>
                return}
        }
        iconify { if $exists {wm iconify $newname; return} }
        destroy { if $exists {destroy $newname; return} }
    }
}

proc vTcl:WindowsCleanup {} {
    global vTcl
    if {[info exists vTcl(sourcing)]} { return }
    foreach w [winfo children .] {
    	wm protocol $w WM_DELETE_WINDOW { exit }
    }
}
}

if {![info exists vTcl(sourcing)]} {
proc {vTcl:DefineAlias} {target alias widgetProc top_or_alias cmdalias} {
    global widget

    set widget($alias) $target
    set widget(rev,$target) $alias

    if {$cmdalias} {
        interp alias {} $alias {} $widgetProc $target
    }

    if {$top_or_alias != ""} {
        set widget($top_or_alias,$alias) $target

        if {$cmdalias} {
            interp alias {} $top_or_alias.$alias {} $widgetProc $target
        }
    }
}

proc {vTcl:DoCmdOption} {target cmd} {
    ## menus are considered toplevel windows
    set parent $target
    while {[winfo class $parent] == "Menu"} {
        set parent [winfo parent $parent]
    }

    regsub -all {\%widget} $cmd $target cmd
    regsub -all {\%top} $cmd [winfo toplevel $parent] cmd

    uplevel #0 [list eval $cmd]
}

proc {vTcl:FireEvent} {target event} {
    foreach bindtag [bindtags $target] {
        set tag_events [bind $bindtag]
        set stop_processing 0
        foreach tag_event $tag_events {
            if {$tag_event == $event} {
                set bind_code [bind $bindtag $tag_event]
                regsub -all %W $bind_code $target bind_code
                set result [catch {uplevel #0 $bind_code} errortext]
                if {$result == 3} {
                    # break exception, stop processing
                    set stop_processing 1
                } elseif {$result != 0} {
                    bgerror $errortext
                }
                break
            }
        }
        if {$stop_processing} {break}
    }
}

proc {vTcl:Toplevel:WidgetProc} {w args} {
    if {[llength $args] == 0} {
        return -code error "wrong # args: should be \"$w option ?arg arg ...?\""
    }

    ## The first argument is a switch, they must be doing a configure.
    if {[string index $args 0] == "-"} {
        set command configure

        ## There's only one argument, must be a cget.
        if {[llength $args] == 1} {
            set command cget
        }
    } else {
        set command [lindex $args 0]
        set args [lrange $args 1 end]
    }

    switch -- $command {
        "hide" -
        "Hide" {
            Window hide $w
        }

        "show" -
        "Show" {
            Window show $w
        }

        "ShowModal" {
            Window show $w
            raise $w
            grab $w
            tkwait window $w
            grab release $w
        }

        default {
            eval $w $command $args
        }
    }
}

proc {vTcl:WidgetProc} {w args} {
    if {[llength $args] == 0} {
        return -code error "wrong # args: should be \"$w option ?arg arg ...?\""
    }

    ## The first argument is a switch, they must be doing a configure.
    if {[string index $args 0] == "-"} {
        set command configure

        ## There's only one argument, must be a cget.
        if {[llength $args] == 1} {
            set command cget
        }
    } else {
        set command [lindex $args 0]
        set args [lrange $args 1 end]
    }

    eval $w $command $args
}

proc {vTcl:toplevel} {args} {
    uplevel #0 eval toplevel $args
    set target [lindex $args 0]
    namespace eval ::$target {}
}
}

if {[info exists vTcl(sourcing)]} {
proc vTcl:project:info {} {
    namespace eval ::widgets::.top21 {
        array set save {-background 1 -highlightbackground 1}
    }
    namespace eval ::widgets::.top21.lab21 {
        array set save {-image 1 -width 1}
    }
    namespace eval ::widgets::.top21.but22 {
        array set save {-activebackground 1 -background 1 -command 1 -height 1 -highlightbackground 1 -pady 1 -text 1 -width 1 -wraplength 1}
    }
    namespace eval ::widgets::.top21.but23 {
        array set save {-activebackground 1 -background 1 -command 1 -height 1 -highlightbackground 1 -pady 1 -text 1 -width 1}
    }
    namespace eval ::widgets::.top22 {
        array set save {}
    }
    namespace eval ::widgets::.top22.fra25 {
        array set save {-background 1 -borderwidth 1 -cursor 1 -height 1 -relief 1 -width 1}
    }
    namespace eval ::widgets::.top22.fra25.mes26 {
        array set save {-background 1 -padx 1 -pady 1 -text 1 -textvariable 1 -width 1}
    }
    namespace eval ::widgets::.top22.but27 {
        array set save {-command 1 -height 1 -pady 1 -text 1 -width 1}
    }
    namespace eval ::widgets::.top22.rad28 {
        array set save {-command 1 -height 1 -text 1 -value 1}
    }
    namespace eval ::widgets::.top22.rad34 {
        array set save {-command 1 -height 1 -text 1}
    }
    namespace eval ::widgets::.top23 {
        array set save {-background 1}
    }
    namespace eval ::widgets::.top23.fra24 {
        array set save {-background 1 -borderwidth 1 -height 1 -relief 1 -width 1}
    }
    namespace eval ::widgets::.top23.fra24.fra35 {
        array set save {-background 1 -borderwidth 1 -height 1 -relief 1 -width 1}
    }
    namespace eval ::widgets::.top23.fra24.fra35.ent36 {
        array set save {-textvariable 1 -width 1}
    }
    namespace eval ::widgets::.top23.fra24.fra35.lab39 {
        array set save {-background 1 -font 1 -text 1}
    }
    namespace eval ::widgets::.top23.fra24.fra41 {
        array set save {-background 1 -borderwidth 1 -height 1 -relief 1 -width 1}
    }
    namespace eval ::widgets::.top23.fra24.fra41.lab39 {
        array set save {-background 1 -font 1 -text 1}
    }
    namespace eval ::widgets::.top23.fra24.fra41.ent22 {
        array set save {-textvariable 1 -width 1}
    }
    namespace eval ::widgets::.top23.fra24.fra42 {
        array set save {-background 1 -borderwidth 1 -height 1 -relief 1 -width 1}
    }
    namespace eval ::widgets::.top23.fra24.fra42.lab39 {
        array set save {-background 1 -font 1 -height 1 -text 1 -width 1}
    }
    namespace eval ::widgets::.top23.fra24.fra42.ent21 {
        array set save {-textvariable 1 -width 1}
    }
    namespace eval ::widgets::.top23.fra24.but21 {
        array set save {-command 1 -font 1 -pady 1 -text 1}
    }
    namespace eval ::widgets::.top23.fra24.but22 {
        array set save {-command 1 -font 1 -pady 1 -text 1}
    }
    namespace eval ::widgets::.top23.fra24.but23 {
        array set save {-command 1 -font 1 -height 1 -pady 1 -text 1 -width 1}
    }
    namespace eval ::widgets::.top23.but23 {
        array set save {-command 1 -font 1 -height 1 -pady 1 -text 1 -width 1 -wraplength 1}
    }
    namespace eval ::widgets::.top23.but24 {
        array set save {-command 1 -font 1 -height 1 -pady 1 -text 1 -width 1}
    }
    namespace eval ::widgets::.top24 {
        array set save {-background 1}
    }
    namespace eval ::widgets::.top24.fra28 {
        array set save {-background 1 -borderwidth 1 -height 1 -relief 1 -width 1}
    }
    namespace eval ::widgets::.top24.fra28.lab30 {
        array set save {-background 1 -font 1 -height 1 -text 1}
    }
    namespace eval ::widgets::.top24.fra28.lab31 {
        array set save {-background 1 -font 1 -height 1 -justify 1 -text 1 -width 1 -wraplength 1}
    }
    namespace eval ::widgets::.top24.fra28.but32 {
        array set save {-activebackground 1 -background 1 -command 1 -height 1 -image 1 -pady 1 -text 1 -width 1}
    }
    namespace eval ::widgets::.top24.fra28.but33 {
        array set save {-activebackground 1 -background 1 -command 1 -height 1 -image 1 -pady 1 -text 1 -width 1}
    }
    namespace eval ::widgets::.top24.fra28.lab39 {
        array set save {-background 1 -font 1 -height 1 -justify 1 -text 1 -width 1 -wraplength 1}
    }
    namespace eval ::widgets::.top24.fra28.fra23 {
        array set save {-background 1 -borderwidth 1 -height 1 -relief 1 -width 1}
    }
    namespace eval ::widgets::.top24.fra28.fra23.but24 {
        array set save {-activebackground 1 -background 1 -command 1 -height 1 -image 1 -pady 1 -text 1 -width 1}
    }
    namespace eval ::widgets::.top24.fra28.fra23.but25 {
        array set save {-activebackground 1 -background 1 -command 1 -height 1 -image 1 -pady 1 -text 1 -width 1}
    }
    namespace eval ::widgets::.top24.fra28.fra23.lab26 {
        array set save {-background 1 -font 1 -height 1 -text 1 -width 1}
    }
    namespace eval ::widgets::.top24.fra28.fra23.lab27 {
        array set save {-background 1 -font 1 -text 1}
    }
    namespace eval ::widgets::.top24.fra28.fra23.lab28 {
        array set save {-background 1 -font 1 -height 1 -text 1 -width 1}
    }
    namespace eval ::widgets::.top24.fra28.fra23.but29 {
        array set save {-activebackground 1 -background 1 -command 1 -height 1 -image 1 -pady 1 -text 1 -width 1}
    }
    namespace eval ::widgets::.top24.fra28.fra23.lab31 {
        array set save {-background 1 -font 1 -text 1 -width 1}
    }
    namespace eval ::widgets::.top24.fra28.fra23.but26 {
        array set save {-activebackground 1 -background 1 -command 1 -height 1 -image 1 -text 1 -width 1}
    }
    namespace eval ::widgets::.top24.fra28.fra23.lab22 {
        array set save {-background 1 -font 1 -height 1 -text 1 -width 1}
    }
    namespace eval ::widgets::.top24.fra28.but30 {
        array set save {-activebackground 1 -background 1 -command 1 -image 1 -pady 1 -text 1}
    }
    namespace eval ::widgets::.top24.fra28.lab32 {
        array set save {-background 1 -font 1 -text 1}
    }
    namespace eval ::widgets::.top25 {
        array set save {-menu 1}
    }
    namespace eval ::widgets::.top25.mes29 {
        array set save {-background 1 -padx 1 -pady 1 -relief 1 -text 1 -width 1}
    }
    namespace eval ::widgets::.top25.lab30 {
        array set save {-font 1 -height 1 -relief 1 -text 1 -width 1}
    }
    namespace eval ::widgets::.top25.ent32 {
        array set save {-textvariable 1 -width 1}
    }
    namespace eval ::widgets::.top25.m33 {
        array set save {-activeborderwidth 1 -borderwidth 1 -cursor 1 -font 1}
    }
    namespace eval ::widgets::.top25.but21 {
        array set save {-command 1 -height 1 -pady 1 -text 1 -width 1}
    }
    namespace eval ::widgets::.top26 {
        array set save {}
    }
    namespace eval ::widgets::.top26.lab27 {
        array set save {-font 1 -height 1 -relief 1 -text 1 -width 1}
    }
    namespace eval ::widgets::.top26.mes29 {
        array set save {-background 1 -padx 1 -pady 1 -relief 1 -text 1 -width 1}
    }
    namespace eval ::widgets::.top26.but30 {
        array set save {-command 1 -height 1 -pady 1 -text 1 -width 1}
    }
    namespace eval ::widgets::.top27 {
        array set save {}
    }
    namespace eval ::widgets::.top27.mes28 {
        array set save {-background 1 -font 1 -padx 1 -pady 1 -relief 1 -text 1 -width 1}
    }
    namespace eval ::widgets::.top27.but29 {
        array set save {-command 1 -height 1 -text 1 -width 1}
    }
    namespace eval ::widgets::.top28 {
        array set save {-background 1}
    }
    namespace eval ::widgets::.top28.ent29 {
        array set save {-background 1 -textvariable 1 -width 1}
    }
    namespace eval ::widgets::.top28.but21 {
        array set save {-command 1 -height 1 -text 1 -width 1}
    }
    namespace eval ::widgets::.top28.but22 {
        array set save {-command 1 -height 1 -text 1 -width 1}
    }
    namespace eval ::widgets::.top28.ent33 {
        array set save {-background 1 -foreground 1 -highlightbackground 1 -relief 1 -selectforeground 1 -state 1 -textvariable 1 -width 1}
    }
    namespace eval ::widgets::.top28.lab21 {
        array set save {-font 1 -height 1 -relief 1 -text 1 -width 1}
    }
    namespace eval ::widgets::.top29 {
        array set save {-menu 1}
    }
    namespace eval ::widgets::.top29.lab30 {
        array set save {-font 1 -relief 1 -text 1 -width 1}
    }
    namespace eval ::widgets::.top29.but32 {
        array set save {-command 1 -height 1 -text 1 -width 1}
    }
    namespace eval ::widgets::.top29.lab21 {
        array set save {-font 1 -relief 1 -text 1 -width 1}
    }
    namespace eval ::widgets::.top29.ent22 {
        array set save {-background 1 -textvariable 1}
    }
    namespace eval ::widgets::.top29.ent23 {
        array set save {-background 1 -textvariable 1}
    }
    namespace eval ::widgets::.top29.m25 {
        array set save {-tearoff 1}
    }
    namespace eval ::widgets::.top29.ent26 {
        array set save {-background 1 -foreground 1 -relief 1 -textvariable 1 -width 1}
    }
    namespace eval ::widgets::.top29.but24 {
        array set save {-command 1 -height 1 -text 1 -width 1}
    }
    namespace eval ::widgets::.top29.but21 {
        array set save {-command 1 -height 1 -text 1 -width 1}
    }
    namespace eval ::widgets::.top30 {
        array set save {}
    }
    namespace eval ::widgets::.top30.ent31 {
        array set save {-background 1 -textvariable 1}
    }
    namespace eval ::widgets::.top30.but32 {
        array set save {-command 1 -height 1 -text 1 -width 1}
    }
    namespace eval ::widgets::.top30.but33 {
        array set save {-command 1 -height 1 -text 1 -width 1}
    }
    namespace eval ::widgets::.top30.lab34 {
        array set save {-font 1 -height 1 -relief 1 -text 1 -width 1}
    }
    namespace eval ::widgets::.top30.ent35 {
        array set save {-background 1 -textvariable 1}
    }
    namespace eval ::widgets::.top30.lab36 {
        array set save {-font 1 -height 1 -relief 1 -text 1 -width 1}
    }
    namespace eval ::widgets::.top32 {
        array set save {-background 1 -menu 1}
    }
    namespace eval ::widgets::.top32.men33 {
        array set save {-activebackground 1 -background 1 -height 1 -menu 1 -padx 1 -pady 1 -text 1 -underline 1 -width 1}
    }
    namespace eval ::widgets::.top32.men33.m {
        array set save {-activeborderwidth 1 -borderwidth 1}
    }
    namespace eval ::widgets::.top32.m24 {
        array set save {-activeborderwidth 1 -borderwidth 1 -cursor 1}
    }
    namespace eval ::widgets::.top32.tex22 {
        array set save {-background 1 -font 1 -height 1 -width 1 -wrap 1 -xscrollcommand 1 -yscrollcommand 1}
    }
    namespace eval ::widgets::.top32.scr23 {
        array set save {-orient 1 -width 1}
    }
    namespace eval ::widgets::.top32.scr24 {
        array set save {-command 1 -width 1}
    }
    namespace eval ::widgets::.top32.che21 {
        array set save {-activebackground 1 -background 1 -command 1 -height 1 -highlightbackground 1 -offvalue 1 -onvalue 1 -state 1 -text 1 -variable 1 -width 1}
    }
    namespace eval ::widgets::.top32.men21 {
        array set save {-activebackground 1 -background 1 -height 1 -menu 1 -padx 1 -pady 1 -text 1 -underline 1 -width 1}
    }
    namespace eval ::widgets::.top32.men21.m {
        array set save {-activeborderwidth 1 -borderwidth 1}
    }
    namespace eval ::widgets::.top32.men23 {
        array set save {-activebackground 1 -background 1 -height 1 -menu 1 -padx 1 -pady 1 -text 1 -underline 1 -width 1}
    }
    namespace eval ::widgets::.top32.men23.m {
        array set save {-activeborderwidth 1 -borderwidth 1}
    }
    namespace eval ::widgets::.top32.men22 {
        array set save {-activebackground 1 -background 1 -height 1 -menu 1 -padx 1 -pady 1 -text 1 -underline 1 -width 1}
    }
    namespace eval ::widgets::.top32.men22.m {
        array set save {-activeborderwidth 1 -borderwidth 1}
    }
    namespace eval ::widgets::.top33 {
        array set save {}
    }
    namespace eval ::widgets::.top33.lab34 {
        array set save {-font 1 -height 1 -relief 1 -text 1 -width 1}
    }
    namespace eval ::widgets::.top33.ent35 {
        array set save {-background 1 -textvariable 1 -width 1}
    }
    namespace eval ::widgets::.top33.but36 {
        array set save {-command 1 -height 1 -text 1 -width 1}
    }
    namespace eval ::widgets::.top33.but21 {
        array set save {-command 1 -height 1 -text 1 -width 1}
    }
    namespace eval ::widgets::.top33.ent23 {
        array set save {-background 1 -font 1 -foreground 1 -relief 1 -state 1 -textvariable 1 -width 1}
    }
    namespace eval ::widgets::.top33.lab22 {
        array set save {-font 1 -height 1 -text 1 -width 1}
    }
    namespace eval ::widgets_bindings {
        set tagslist {menubindings selectall buscar pastetext}
    }
}
}
#################################
# USER DEFINED PROCEDURES
#
###########################################################
## Procedure:  AbrirArchivo

proc {AbrirArchivo} {} {
global widget archivo titulo titulosm
set archivo [tk_getOpenFile -title "Abrir archivo..."]
if { ![catch {set arch_id [open $archivo r] }] } {
    while {![eof $arch_id]} {
	$widget(areatexto) insert end [read $arch_id 1000]
    }
    close $arch_id
    $widget(areatexto) mark set insert 1.0

wm title .top32 "$titulosm - $archivo"
}
}
###########################################################
## Procedure:  BuscarTexto

proc {BuscarTexto} {t} {
global widget spos alarma


set alarma ""
set spos [$widget(areatexto) search -count len -nocase -forward $t $spos end]
set len [string length $t]

if { $spos != "" } {

    $widget(areatexto) see $spos

    tkTextSetCursor $widget(areatexto) $spos
    $widget(areatexto) tag add sel $spos "$spos + $len char"
    set spos "$spos + $len char"
    
    } else {

    set spos "0.0"

    set alarma "No se encontro el texto"
    
}

focus $widget(areatexto)
}
###########################################################
## Procedure:  Clipf

proc {Clipf} {x} {
global widget

# Respaldar clipboard si es que contiene algo
# 
if { [string compare $x "respaldar"] && ![catch [selection get -selection CLIPBOARD]] } {
    set cbak [selection get -selection CLIPBOARD]
    unset b
    return 0
}
#

# Restaurar Clipboard
# 
if { [string compare $x "restaurar"] && [info exists cbak]} {
    clipboard clear
    clipboard append $cbak
    unset r cbak
}
#
#
}
###########################################################
## Procedure:  ErrorConf

proc {ErrorConf} {} {
global widget path

Window show $widget(ErrorConfWin)
}
###########################################################
## Procedure:  GuardarArchivo

proc {GuardarArchivo} {} {
global widget archivo


if ![info exists archivo] {
    set archivo ""
}

if { $archivo == "" } {
    GuardarCArchivo
} else {
    set n [open $archivo w]
    puts $n [$widget(areatexto) get 1.0 end]
    close $n
}
}
###########################################################
## Procedure:  GuardarCArchivo

proc {GuardarCArchivo} {} {
global widget

set f [tk_getSaveFile -title "Guardar como..."]
if { ![ catch { set n [open $f w] }] } {
    puts $n [$widget(areatexto) get 1.0 end]
    close $n
    }
}
###########################################################
## Procedure:  NuevoArchivo

proc {NuevoArchivo} {} {
global widget archivo titulo
$widget(areatexto) delete 1.0 end
set archivo ""
wm title .top32 $titulo
}
###########################################################
## Procedure:  ProcAyuda

proc {ProcAyuda} {} {
global widget navpath path ayuda ayudadoc

if ![ file exists $navpath ] {
    Window show $widget(no_nav)
} else {
set path [pwd];append ayuda $path $ayudadoc;exec $navpath $ayuda
}


#Reiniciar el path de "ayuda" para uso futuro de ayuda
set ayuda ""
}
###########################################################
## Procedure:  ReemplazarTexto

proc {ReemplazarTexto} {t rt} {
global widget spos alarma


set alarma ""
set spos [$widget(areatexto) search -count len -nocase -forward $t $spos end]
set len [string length $t]

if { $spos != "" } {

    $widget(areatexto) see $spos
    $widget(areatexto) delete $spos "$spos + $len char"
    $widget(areatexto) insert $spos $rt

    tkTextSetCursor $widget(areatexto) $spos
    $widget(areatexto) tag add sel $spos "$spos + $len char"
    set spos "$spos + $len char"

    } else {

    set spos "0.0"

    set alarma "No se encontro el texto"
    
}

focus $widget(areatexto)
}
###########################################################
## Procedure:  RespaldarCB

proc {RespaldarCB} {} {
global widget

# Respaldar clipboard si es que contiene algo
# 
if ![catch [selection get -selection CLIPBOARD]] {
    set cbak [selection get -selection CLIPBOARD]
}
#
}
###########################################################
## Procedure:  RestaurarCB

proc {RestaurarCB} {} {
global widget cbak
}
###########################################################
## Procedure:  Salir

proc {Salir} {} {
global widget

if {[tk_messageBox -default no -icon question -message "Estas seguro que quieres salir?" -title "Seguro?" -type yesno] =="no"} {
    
    return
    
}

exit
}
###########################################################
## Procedure:  VarsEntorno

proc {VarsEntorno} {} {
global widget navpath mailpath msgpath rauto titulo titulosm printcom printopt ayudadoc tmp

# Abrir archivo de configuracion
set cfgID [open config.ini {RDONLY CREAT}]
#set cfgTMP [open config.txt {RDWR CREAT TRUNC}]


# Dos opciones para leer el archivo de configuracion
# Read es 10% mas rapido en archivos por encima de 1K

#Leer datos usando read
#foreach line [split [read $cfgID] \n] {
#    foreach val [lindex [split $line =] 1] {
#        puts $cfgTMP $val
#    }
#}
#
#
#
set blah 0

#Leer los datos usando gets
while {[gets $cfgID line] >= 0} {

    set var [lrange [split $line =] 1 end]

    switch -exact -- $blah {
        0 { set navpath [string trim $var \{\}] }
        1 { set mailpath [string trim $var \{\}] }
        2 { set msgpath [string trim $var \{\}] }
    }

incr blah

}



#
#

#
#Cerrar archivo
#close $cfgTMP
close $cfgID


#Variable de retorno automatico (wordwrap)
# Activar retorno automatico por default

set rauto "word"


#Titulo principal normal
set titulo "ALIZEE 0.9 - Raza Mexicana Hackers Team"

#Titulo principal chico
set titulosm "ALIZEE 0.9"

#Comando y opciones de impresion
set printcom "lpr"
set printopt ""

#Documento de ayuda (HTML)
set ayudadoc "/doc/ayuda.html"


#Archivo temporal para impresion
set tmp "alizee.tmp"
}
###########################################################
## Procedure:  init
###########################################################
## Procedure:  main

proc {main} {argc argv} {
global titulo
#wm protocol .top32 WM_DELETE_WINDOW {exit}
wm protocol .top32 WM_DELETE_WINDOW {Salir}

wm title .top32 $titulo
}

proc init {argc argv} {
#Preparar las variables de entorno
#para las utilerias
#
VarsEntorno
#package require solitaire
#namespace import ::solitaire::*
}

init $argc $argv

#################################
# VTCL GENERATED GUI PROCEDURES
#

proc vTclWindow. {base {container 0}} {
    if {$base == ""} {
        set base .
    }
    ###################
    # CREATING WIDGETS
    ###################
    if {!$container} {
    wm focusmodel $base passive
    wm geometry $base 200x200+132+132; update
    wm maxsize $base 1028 753
    wm minsize $base 104 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm withdraw $base
    wm title $base "vtcl"
    bindtags $base "$base Vtcl all"
    vTcl:FireEvent $base <<Create>>
    }
    ###################
    # SETTING GEOMETRY
    ###################

    vTcl:FireEvent $base <<Ready>>
}

proc vTclWindow.top21 {base {container 0}} {
    if {$base == ""} {
        set base .top21
    }
    if {[winfo exists $base] && (!$container)} {
        wm deiconify $base; return
    }

    global widget
    vTcl:DefineAlias "$base" "acerca_de" vTcl:Toplevel:WidgetProc "" 1
    vTcl:DefineAlias "$base.but22" "Button1" vTcl:WidgetProc "acerca_de" 1
    vTcl:DefineAlias "$base.but23" "Button2" vTcl:WidgetProc "acerca_de" 1
    vTcl:DefineAlias "$base.lab21" "Label1" vTcl:WidgetProc "acerca_de" 1

    ###################
    # CREATING WIDGETS
    ###################
    if {!$container} {
    vTcl:toplevel $base -class Toplevel \
        -background #000000 -highlightbackground #ffffff 
    wm withdraw $base
    wm focusmodel $base passive
    wm geometry $base 142x248+523+12; update
    wm maxsize $base 804 585
    wm minsize $base 110 2
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm title $base "Acerca de"
    vTcl:FireEvent $base <<Create>>
    }
    label $base.lab21 \
        \
        -image [vTcl:image:get_image [file join C:/ {My Documents} alizee alizee graf acerca.gif]] \
        -width 140 
    button $base.but22 \
        -activebackground #c0c0c0 -background #c0c0c0 \
        -command {Window show $widget(copyleft)} -height 16 \
        -highlightbackground #000000 -pady 0 -text Copyleft -width 56 \
        -wraplength 50 
    button $base.but23 \
        -activebackground #c0c0c0 -background #c0c0c0 \
        -command {Window hide $widget(acerca_de)} -height 16 \
        -highlightbackground #000000 -pady 0 -text Cerrar -width 56 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.lab21 \
        -x 1 -y 0 -width 140 -height 214 -anchor nw -bordermode ignore 
    place $base.but22 \
        -x 8 -y 220 -width 56 -height 16 -anchor nw -bordermode ignore 
    place $base.but23 \
        -x 79 -y 220 -width 56 -height 16 -anchor nw -bordermode ignore 

    vTcl:FireEvent $base <<Ready>>
}

proc vTclWindow.top22 {base {container 0}} {
    if {$base == ""} {
        set base .top22
    }
    if {[winfo exists $base] && (!$container)} {
        wm deiconify $base; return
    }

    global widget
    vTcl:DefineAlias "$base" "copyleft" vTcl:Toplevel:WidgetProc "" 1
    vTcl:DefineAlias "$base.rad28" "Radiobutton1" vTcl:WidgetProc "copyleft" 1
    vTcl:DefineAlias "$base.rad34" "Radiobutton4" vTcl:WidgetProc "copyleft" 1

    ###################
    # CREATING WIDGETS
    ###################
    if {!$container} {
    vTcl:toplevel $base -class Toplevel
    wm withdraw $base
    wm focusmodel $base passive
    wm geometry $base 415x434+105+134; update
    wm maxsize $base 804 585
    wm minsize $base 108 2
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm title $base "Licencia General Pblica GNU - Resumen"
    vTcl:FireEvent $base <<Create>>
    }
    frame $base.fra25 \
        -background #ffffff -borderwidth 2 -cursor fleur -height 370 \
        -relief groove -width 415 
    message $base.fra25.mes26 \
        -background #ffffff -padx 5 -pady 2 \
        -text {This is an unofficial translation into Spanish.
Esta es una traduccin no oficial al Espaol.
-----------------------------------------------

Alizee v. 0.9 - Editor de texto criptografico
Derechos reservados (C) 2001 Tecuhtli Nahual

Este programa es software libre; lo puede distribuir y/o
modificar bajo los trminos de de la Licencia General Pblica
como est publicada por la Fundacion de Software Libre
(Free Software Foundation); ya sea la version 2 de la Licencia,
o (opcionalmente) cualquier version futura.

Este programa es distribuido con el deseo de que sea til,
pero SIN NINGUNA GARANTIA; sin siquiera la supuesta
garanta de MERCANTIBILIDAD, o APTITUD DE SERVIR
PARA UN PROPOSITO EN PARTICULAR. Ver la Licencia
General Pblica GNU para mayores detalles.

Debera haber recibido una copia de la Licencia Pblica General
junto con este programa; si no es as, escriba a Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston MA 02111-1307, USA.} \
        -textvariable gnu_gpl -width 376 
    button $base.but27 \
        -command {Window hide $widget(copyleft)} -height 0 -pady 0 \
        -text Cerrar -width 0 
    radiobutton $base.rad28 \
        \
        -command {set gnu_gpl "Alizee v. 0.9 - Cross-Platform Encripting Editor
Copyright (C) 2001 Tecuhtli Nahual

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied
warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU General
Public License for more details.

You should have received a copy of the GNU General Public
License along with this program; if not, write to the
Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA."} \
        -height 0 -text English -value 0 
    radiobutton $base.rad34 \
        \
        -command {set gnu_gpl "This is an unofficial translation into Spanish.
Esta es una traduccin no oficial al Espaol.
-----------------------------------------------

Alizee v. 0.9 - Editor de texto criptografico
Derechos reservados (C) 2001 Tecuhtli Nahual

Este programa es software libre; lo puede distribuir y/o
modificar bajo los trminos de de la Licencia General Pblica
como est publicada por la Fundacion de Software Libre
(Free Software Foundation); ya sea la version 2 de la Licencia,
o (opcionalmente) cualquier version futura.

Este programa es distribuido con el deseo de que sea til,
pero SIN NINGUNA GARANTIA; sin siquiera la supuesta
garanta de MERCANTIBILIDAD, o APTITUD DE SERVIR
PARA UN PROPOSITO EN PARTICULAR. Ver la Licencia
General Pblica GNU para mayores detalles.

Debera haber recibido una copia de la Licencia Pblica General
junto con este programa; si no es as, escriba a Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston MA 02111-1307, USA."} \
        -height 0 -text {Espaol (no oficial)} 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.fra25 \
        -x 0 -y 0 -width 415 -height 370 -anchor nw -bordermode ignore 
    place $base.fra25.mes26 \
        -x 20 -y 5 -width 376 -height 361 -anchor nw -bordermode ignore 
    place $base.but27 \
        -x 180 -y 390 -width 43 -height 26 -anchor nw -bordermode ignore 
    place $base.rad28 \
        -x 19 -y 401 -width 71 -height 22 -anchor nw -bordermode ignore 
    place $base.rad34 \
        -x 10 -y 381 -width 144 -height 22 -anchor nw -bordermode ignore 

    vTcl:FireEvent $base <<Ready>>
}

proc vTclWindow.top23 {base {container 0}} {
    if {$base == ""} {
        set base .top23
    }
    if {[winfo exists $base] && (!$container)} {
        wm deiconify $base; return
    }

    global widget
    vTcl:DefineAlias "$base" "config" vTcl:Toplevel:WidgetProc "" 1
    vTcl:DefineAlias "$base.but23" "Button13" vTcl:WidgetProc "config" 1
    vTcl:DefineAlias "$base.but24" "Button14" vTcl:WidgetProc "config" 1
    vTcl:DefineAlias "$base.fra24" "Frame5" vTcl:WidgetProc "config" 1
    vTcl:DefineAlias "$base.fra24.but21" "Button15" vTcl:WidgetProc "config" 1
    vTcl:DefineAlias "$base.fra24.but22" "Button16" vTcl:WidgetProc "config" 1
    vTcl:DefineAlias "$base.fra24.but23" "Button17" vTcl:WidgetProc "config" 1
    vTcl:DefineAlias "$base.fra24.fra35" "Frame6" vTcl:WidgetProc "config" 1
    vTcl:DefineAlias "$base.fra24.fra35.ent36" "Entry1" vTcl:WidgetProc "config" 1
    vTcl:DefineAlias "$base.fra24.fra35.lab39" "Label15" vTcl:WidgetProc "config" 1
    vTcl:DefineAlias "$base.fra24.fra41" "Frame8" vTcl:WidgetProc "config" 1
    vTcl:DefineAlias "$base.fra24.fra41.ent22" "Entry12" vTcl:WidgetProc "config" 1
    vTcl:DefineAlias "$base.fra24.fra41.lab39" "Label16" vTcl:WidgetProc "config" 1
    vTcl:DefineAlias "$base.fra24.fra42" "Frame9" vTcl:WidgetProc "config" 1
    vTcl:DefineAlias "$base.fra24.fra42.ent21" "Entry11" vTcl:WidgetProc "config" 1
    vTcl:DefineAlias "$base.fra24.fra42.lab39" "Label17" vTcl:WidgetProc "config" 1

    ###################
    # CREATING WIDGETS
    ###################
    if {!$container} {
    vTcl:toplevel $base -class Toplevel \
        -background #000000 
    wm withdraw $base
    wm focusmodel $base passive
    wm geometry $base 394x199+523+369; update
    wm maxsize $base 804 585
    wm minsize $base 108 2
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm title $base "Configuracion"
    vTcl:FireEvent $base <<Create>>
    }
    frame $base.fra24 \
        -background #c0c0c0 -borderwidth 2 -height 155 -relief ridge \
        -width 385 
    frame $base.fra24.fra35 \
        -background #c0c0c0 -borderwidth 2 -height 45 -relief ridge \
        -width 370 
    entry $base.fra24.fra35.ent36 \
        -textvariable navpath -width 292 
    label $base.fra24.fra35.lab39 \
        -background #c0c0c0 -font {Helvetica -10 bold} -text Navegador 
    frame $base.fra24.fra41 \
        -background #c0c0c0 -borderwidth 2 -height 45 -relief ridge \
        -width 370 
    label $base.fra24.fra41.lab39 \
        -background #c0c0c0 -font {Helvetica -10 bold} \
        -text {Correo Electrnico} 
    entry $base.fra24.fra41.ent22 \
        -textvariable mailpath -width 296 
    frame $base.fra24.fra42 \
        -background #c0c0c0 -borderwidth 2 -height 45 -relief ridge \
        -width 370 
    label $base.fra24.fra42.lab39 \
        -background #c0c0c0 -font {Helvetica -10 bold} -height 0 \
        -text {Mensajero Instantaneo} -width 0 
    entry $base.fra24.fra42.ent21 \
        -textvariable msgpath -width 291 
    button $base.fra24.but21 \
        \
        -command {global widget
set navpath [tk_getOpenFile -title "Seleccionar Navegador de Web"]} \
        -font {Helvetica -10 bold} -pady 0 -text Seleccionar 
    button $base.fra24.but22 \
        \
        -command {global widget
set mailpath [tk_getOpenFile -title "Seleccionar Cliente de Correo"]} \
        -font {Helvetica -10 bold} -pady 0 -text Seleccionar 
    button $base.fra24.but23 \
        \
        -command {global widget
set msgpath [tk_getOpenFile -title "Seleccionar Mensajero"]} \
        -font {Helvetica -10 bold} -height 19 -pady 0 -text Seleccionar \
        -width 65 
    button $base.but23 \
        \
        -command {global navpath, mailpath, msgpath

# 
set cfgID [open config.ini {RDWR CREAT TRUNC}]
    
# # Actualizar/Cerrar archivo de configuracion y salir
puts $cfgID "navigator=$navpath"
puts $cfgID "mail_client=$mailpath"
puts $cfgID "instant_messenger=$msgpath"

close $cfgID} \
        -font {Helvetica -10 bold} -height 29 -pady 0 \
        -text {Guardar Configuracin} -width 75 -wraplength 100 
    button $base.but24 \
        -command {Window hide $widget(config)} -font {Helvetica -10 bold} \
        -height 31 -pady 0 -text Cerrar -width 43 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.fra24 \
        -x 4 -y 5 -width 385 -height 155 -anchor nw -bordermode ignore 
    place $base.fra24.fra35 \
        -x 10 -y 15 -width 370 -height 45 -anchor nw -bordermode ignore 
    place $base.fra24.fra35.ent36 \
        -x 6 -y 16 -width 292 -height 19 -anchor nw -bordermode ignore 
    place $base.fra24.fra35.lab39 \
        -x 10 -y -5 -anchor nw -bordermode ignore 
    place $base.fra24.fra41 \
        -x 10 -y 55 -width 370 -height 45 -anchor nw -bordermode ignore 
    place $base.fra24.fra41.lab39 \
        -x 10 -y -5 -anchor nw -bordermode ignore 
    place $base.fra24.fra41.ent22 \
        -x 6 -y 16 -width 292 -height 19 -anchor nw -bordermode ignore 
    place $base.fra24.fra42 \
        -x 10 -y 98 -width 370 -height 45 -anchor nw -bordermode ignore 
    place $base.fra24.fra42.lab39 \
        -x 10 -y -5 -width 114 -height 19 -anchor nw -bordermode ignore 
    place $base.fra24.fra42.ent21 \
        -x 6 -y 16 -width 292 -height 19 -anchor nw -bordermode ignore 
    place $base.fra24.but21 \
        -x 309 -y 31 -width 65 -height 19 -anchor nw -bordermode ignore 
    place $base.fra24.but22 \
        -x 309 -y 71 -width 65 -height 19 -anchor nw -bordermode ignore 
    place $base.fra24.but23 \
        -x 309 -y 114 -width 65 -height 19 -anchor nw -bordermode ignore 
    place $base.but23 \
        -x 5 -y 165 -width 78 -height 30 -anchor nw -bordermode ignore 
    place $base.but24 \
        -x 94 -y 165 -width 78 -height 30 -anchor nw -bordermode ignore 

    vTcl:FireEvent $base <<Ready>>
}

proc vTclWindow.top24 {base {container 0}} {
    if {$base == ""} {
        set base .top24
    }
    if {[winfo exists $base] && (!$container)} {
        wm deiconify $base; return
    }

    global widget
    vTcl:DefineAlias "$base" "utilerias" vTcl:Toplevel:WidgetProc "" 1
    vTcl:DefineAlias "$base.fra28" "Frame1" vTcl:WidgetProc "utilerias" 1
    vTcl:DefineAlias "$base.fra28.but30" "Button10" vTcl:WidgetProc "utilerias" 1
    vTcl:DefineAlias "$base.fra28.but32" "Button3" vTcl:WidgetProc "utilerias" 1
    vTcl:DefineAlias "$base.fra28.but33" "Button4" vTcl:WidgetProc "utilerias" 1
    vTcl:DefineAlias "$base.fra28.fra23" "Frame4" vTcl:WidgetProc "utilerias" 1
    vTcl:DefineAlias "$base.fra28.fra23.but24" "Button8" vTcl:WidgetProc "utilerias" 1
    vTcl:DefineAlias "$base.fra28.fra23.but25" "Button9" vTcl:WidgetProc "utilerias" 1
    vTcl:DefineAlias "$base.fra28.fra23.but26" "Button20" vTcl:WidgetProc "utilerias" 1
    vTcl:DefineAlias "$base.fra28.fra23.but29" "Button5" vTcl:WidgetProc "utilerias" 1
    vTcl:DefineAlias "$base.fra28.fra23.lab22" "Label24" vTcl:WidgetProc "utilerias" 1
    vTcl:DefineAlias "$base.fra28.fra23.lab26" "Label7" vTcl:WidgetProc "utilerias" 1
    vTcl:DefineAlias "$base.fra28.fra23.lab27" "Label9" vTcl:WidgetProc "utilerias" 1
    vTcl:DefineAlias "$base.fra28.fra23.lab28" "Label6" vTcl:WidgetProc "utilerias" 1
    vTcl:DefineAlias "$base.fra28.fra23.lab31" "Label10" vTcl:WidgetProc "utilerias" 1
    vTcl:DefineAlias "$base.fra28.lab30" "Label4" vTcl:WidgetProc "utilerias" 1
    vTcl:DefineAlias "$base.fra28.lab31" "Label5" vTcl:WidgetProc "utilerias" 1
    vTcl:DefineAlias "$base.fra28.lab32" "Label11" vTcl:WidgetProc "utilerias" 1
    vTcl:DefineAlias "$base.fra28.lab39" "Label8" vTcl:WidgetProc "utilerias" 1

    ###################
    # CREATING WIDGETS
    ###################
    if {!$container} {
    vTcl:toplevel $base -class Toplevel \
        -background #000000 
    wm withdraw $base
    wm focusmodel $base passive
    wm geometry $base 144x334+523+12; update
    wm maxsize $base 804 585
    wm minsize $base 110 2
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm title $base "Utilerias"
    vTcl:FireEvent $base <<Create>>
    }
    frame $base.fra28 \
        -background #c0c0c0 -borderwidth 2 -height 325 -relief ridge \
        -width 135 
    label $base.fra28.lab30 \
        -background #c0c0c0 -font {Helvetica -10 bold} -height 0 \
        -text Navegador 
    label $base.fra28.lab31 \
        -background #c0c0c0 -font {Helvetica -10 bold} -height 0 \
        -justify left -text {Correo Electronico} -width 61 -wraplength 60 
    button $base.fra28.but32 \
        -activebackground #ffffff -background #ffffff \
        -command {if {[file exists $navpath] && [file executable $navpath]} {
    exec $navpath &
    } else {
    set path $navpath
    ErrorConf
}} \
        -height 27 \
        -image [vTcl:image:get_image [file join C:/ {My Documents} alizee alizee graf navegador.gif]] \
        -pady 0 -text button -width 29 
    button $base.fra28.but33 \
        -activebackground #ffffff -background #ffffff \
        -command {if {[file exists $mailpath] && [file executable $mailpath]} {
    exec $mailpath &
    } else {
    set path $mailpath
    ErrorConf
}} \
        -height 25 \
        -image [vTcl:image:get_image [file join C:/ {My Documents} alizee alizee graf correo.gif]] \
        -pady 0 -text button -width 32 
    label $base.fra28.lab39 \
        -background #c0c0c0 -font {Helvetica -10 bold} -height 0 \
        -justify left -text {Mensajero Instantaneo} -width 64 -wraplength 100 
    frame $base.fra28.fra23 \
        -background #c0c0c0 -borderwidth 2 -height 155 -relief ridge \
        -width 125 
    button $base.fra28.fra23.but24 \
        -activebackground #ffffff -background #ffffff \
        -command {Window show $widget(config)} -height 25 \
        -image [vTcl:image:get_image [file join C:/ {My Documents} alizee alizee graf configuracion.gif]] \
        -pady 0 -text button -width 25 
    button $base.fra28.fra23.but25 \
        -activebackground #ffffff -background #ffffff -command ProcAyuda \
        -height 0 \
        -image [vTcl:image:get_image [file join C:/ {My Documents} alizee alizee graf ayuda.gif]] \
        -pady 0 -text button -width 0 
    label $base.fra28.fra23.lab26 \
        -background #c0c0c0 -font {Helvetica -10 bold} -height 0 \
        -text Configuracion -width 71 
    label $base.fra28.fra23.lab27 \
        -background #c0c0c0 -font {Helvetica -10 bold} -text Ayuda 
    label $base.fra28.fra23.lab28 \
        -background #c0c0c0 -font {Helvetica -10 bold} -height 0 \
        -text Encripcion -width 0 
    button $base.fra28.fra23.but29 \
        -activebackground #ffffff -background #ffffff \
        -command {global widget

# Funcion para encripcion/desencripcion

catch [unset cbak]

if ![catch {selection get -selection CLIPBOARD}] {
    set cbak [selection get -selection CLIPBOARD]
}    

#
clipboard clear
tk_textCopy $widget(areatexto)



if [catch {set sel [selection get -selection CLIPBOARD]}] {

    Window show $widget(no_select)

} else {

#Desplegar ventana de encripcion y desencripcion
#
#

    set accion "Encripcion"
    Window show $widget(ventenc)

}} \
        -height 27 \
        -image [vTcl:image:get_image [file join C:/ {My Documents} alizee alizee graf encripcion.gif]] \
        -pady 0 -text button -width 32 
    label $base.fra28.fra23.lab31 \
        -background #c0c0c0 -font {Helvetica -10 bold} \
        -text {Servicios de Programa} -width 114 
    button $base.fra28.fra23.but26 \
        -activebackground #ffffff -background #ffffff \
        -command {global widget

# Funcion para encripcion/desencripcion

catch [unset cbak]

if ![catch {selection get -selection CLIPBOARD}] {
    set cbak [selection get -selection CLIPBOARD]
}    

#
clipboard clear
tk_textCopy $widget(areatexto)



if [catch {set sel [selection get -selection CLIPBOARD]}] {

    Window show $widget(no_select)

} else {

#Desplegar ventana de encripcion y desencripcion
#
#
#
    set accion "Desencripcion"
    Window show $widget(ventenc)

}} \
        -height 26 \
        -image [vTcl:image:get_image [file join C:/ {My Documents} alizee alizee graf desencripcion.gif]] \
        -text button -width 27 
    label $base.fra28.fra23.lab22 \
        -background #c0c0c0 -font {Helvetica -10 bold} -height 0 \
        -text Desencripcion -width 0 
    button $base.fra28.but30 \
        -activebackground #ffffff -background #ffffff \
        -command {if {[file exists $msgpath] && [file executable $msgpath]} {
    exec $msgpath &
    } else {
    set path $msgpath
    ErrorConf
}} \
        -image [vTcl:image:get_image [file join C:/ {My Documents} alizee alizee graf mensajero.gif]] \
        -pady 0 -text button 
    label $base.fra28.lab32 \
        -background #c0c0c0 -font {Helvetica -10 bold} \
        -text {Servicios de Sistema} 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.fra28 \
        -x 5 -y 5 -width 135 -height 325 -anchor nw -bordermode ignore 
    place $base.fra28.lab30 \
        -x 56 -y 28 -width 59 -height 19 -anchor nw -bordermode ignore 
    place $base.fra28.lab31 \
        -x 56 -y 66 -width 61 -height 34 -anchor nw -bordermode ignore 
    place $base.fra28.but32 \
        -x 17 -y 25 -width 29 -height 27 -anchor nw -bordermode ignore 
    place $base.fra28.but33 \
        -x 17 -y 70 -width 29 -height 27 -anchor nw -bordermode ignore 
    place $base.fra28.lab39 \
        -x 56 -y 110 -width 64 -height 39 -anchor nw -bordermode ignore 
    place $base.fra28.fra23 \
        -x 5 -y 165 -width 125 -height 155 -anchor nw -bordermode ignore 
    place $base.fra28.fra23.but24 \
        -x 10 -y 83 -width 29 -height 27 -anchor nw -bordermode ignore 
    place $base.fra28.fra23.but25 \
        -x 10 -y 113 -width 29 -height 27 -anchor nw -bordermode ignore 
    place $base.fra28.fra23.lab26 \
        -x 47 -y 87 -width 71 -height 19 -anchor nw -bordermode ignore 
    place $base.fra28.fra23.lab27 \
        -x 46 -y 117 -width 36 -height 19 -anchor nw -bordermode ignore 
    place $base.fra28.fra23.lab28 \
        -x 46 -y 27 -width 56 -height 19 -anchor nw -bordermode ignore 
    place $base.fra28.fra23.but29 \
        -x 10 -y 23 -width 29 -height 27 -anchor nw -bordermode ignore 
    place $base.fra28.fra23.lab31 \
        -x 5 -y -5 -width 114 -height 19 -anchor nw -bordermode ignore 
    place $base.fra28.fra23.but26 \
        -x 10 -y 53 -width 29 -height 27 -anchor nw -bordermode ignore 
    place $base.fra28.fra23.lab22 \
        -x 45 -y 57 -anchor nw -bordermode ignore 
    place $base.fra28.but30 \
        -x 18 -y 115 -width 29 -height 27 -anchor nw -bordermode ignore 
    place $base.fra28.lab32 \
        -x 15 -y -4 -width 104 -height 19 -anchor nw -bordermode ignore 

    vTcl:FireEvent $base <<Ready>>
}

proc vTclWindow.top25 {base {container 0}} {
    if {$base == ""} {
        set base .top25
    }
    if {[winfo exists $base] && (!$container)} {
        wm deiconify $base; return
    }

    global widget
    vTcl:DefineAlias "$base" "ErrorConfWin" vTcl:Toplevel:WidgetProc "" 1
    vTcl:DefineAlias "$base.but21" "Button18" vTcl:WidgetProc "ErrorConfWin" 1
    vTcl:DefineAlias "$base.ent32" "Entry13" vTcl:WidgetProc "ErrorConfWin" 1
    vTcl:DefineAlias "$base.lab30" "Label20" vTcl:WidgetProc "ErrorConfWin" 1
    vTcl:DefineAlias "$base.mes29" "Message1" vTcl:WidgetProc "ErrorConfWin" 1

    ###################
    # CREATING WIDGETS
    ###################
    if {!$container} {
    vTcl:toplevel $base -class Toplevel \
        -menu "$base.m33" 
    wm withdraw $base
    wm focusmodel $base passive
    wm geometry $base 263x120+15+62; update
    wm maxsize $base 804 585
    wm minsize $base 108 1
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm title $base "Error..."
    vTcl:FireEvent $base <<Create>>
    }
    message $base.mes29 \
        -background #ffffff -padx 5 -pady 2 -relief ridge \
        -text {El archivo no existe o no es ejecutable} -width 251 
    label $base.lab30 \
        -font {Helvetica -11} -height 0 -relief ridge \
        -text {Error de Configuracion} -width 116 
    entry $base.ent32 \
        -textvariable path -width 251 
    menu $base.m33 \
        -activeborderwidth 1 -borderwidth 1 -cursor {} \
        -font {{Times New Roman} 8} 
    button $base.but21 \
        -command {Window hide $widget(ErrorConfWin)} -height 16 -pady 0 \
        -text Cerrar -width 45 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.mes29 \
        -x 5 -y 58 -width 250 -height 34 -anchor nw -bordermode ignore 
    place $base.lab30 \
        -x 5 -y 10 -width 116 -height 19 -anchor nw -bordermode ignore 
    place $base.ent32 \
        -x 5 -y 35 -width 250 -height 19 -anchor nw -bordermode ignore 
    place $base.but21 \
        -x 102 -y 97 -width 45 -height 16 -anchor nw -bordermode ignore 

    vTcl:FireEvent $base <<Ready>>
}

proc vTclWindow.top26 {base {container 0}} {
    if {$base == ""} {
        set base .top26
    }
    if {[winfo exists $base] && (!$container)} {
        wm deiconify $base; return
    }

    global widget
    vTcl:DefineAlias "$base" "no_select" vTcl:Toplevel:WidgetProc "" 1
    vTcl:DefineAlias "$base.but30" "Button19" vTcl:WidgetProc "no_select" 1
    vTcl:DefineAlias "$base.lab27" "Label21" vTcl:WidgetProc "no_select" 1
    vTcl:DefineAlias "$base.mes29" "Message2" vTcl:WidgetProc "no_select" 1

    ###################
    # CREATING WIDGETS
    ###################
    if {!$container} {
    vTcl:toplevel $base -class Toplevel
    wm withdraw $base
    wm focusmodel $base passive
    wm geometry $base 202x117+172+295; update
    wm maxsize $base 804 585
    wm minsize $base 108 2
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm title $base "Error..."
    vTcl:FireEvent $base <<Create>>
    }
    label $base.lab27 \
        -font {Helvetica -11} -height 0 -relief ridge \
        -text {Error de Seleccion} -width 0 
    message $base.mes29 \
        -background #ffffff -padx 5 -pady 2 -relief ridge \
        -text {Por favor selecciona el texto a [des]encriptar} -width 151 
    button $base.but30 \
        -command {Window hide $widget(no_select)} -height 16 -pady 0 \
        -text Cerrar -width 45 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.lab27 \
        -x 25 -y 12 -width 95 -height 18 -anchor nw -bordermode ignore 
    place $base.mes29 \
        -x 25 -y 40 -width 151 -height 41 -anchor nw -bordermode ignore 
    place $base.but30 \
        -x 76 -y 92 -width 45 -height 16 -anchor nw -bordermode ignore 

    vTcl:FireEvent $base <<Ready>>
}

proc vTclWindow.top27 {base {container 0}} {
    if {$base == ""} {
        set base .top27
    }
    if {[winfo exists $base] && (!$container)} {
        wm deiconify $base; return
    }

    global widget
    vTcl:DefineAlias "$base" "no_nav" vTcl:Toplevel:WidgetProc "" 1
    vTcl:DefineAlias "$base.but29" "Button24" vTcl:WidgetProc "no_nav" 1
    vTcl:DefineAlias "$base.mes28" "Message3" vTcl:WidgetProc "no_nav" 1

    ###################
    # CREATING WIDGETS
    ###################
    if {!$container} {
    vTcl:toplevel $base -class Toplevel
    wm withdraw $base
    wm focusmodel $base passive
    wm geometry $base 202x117+523+370; update
    wm maxsize $base 1009 738
    wm minsize $base 106 2
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm title $base "Navegador Invalido"
    vTcl:FireEvent $base <<Create>>
    }
    message $base.mes28 \
        -background #ffffff -font {Helvetica -11} -padx 5 -pady 2 \
        -relief ridge \
        -text {El texto de ayuda esta en formato HTML. 

Un navegador valido debe ser definido en la configuracion.} \
        -width 170 
    button $base.but29 \
        -command {Window hide $widget(no_nav)} -height 0 -text Cerrar \
        -width 0 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.mes28 \
        -x 8 -y 8 -width 185 -height 80 -anchor nw -bordermode ignore 
    place $base.but29 \
        -x 73 -y 93 -width 48 -height 16 -anchor nw -bordermode ignore 

    vTcl:FireEvent $base <<Ready>>
}

proc vTclWindow.top28 {base {container 0}} {
    if {$base == ""} {
        set base .top28
    }
    if {[winfo exists $base] && (!$container)} {
        wm deiconify $base; return
    }

    global widget
    vTcl:DefineAlias "$base" "busqueda" vTcl:Toplevel:WidgetProc "" 1
    vTcl:DefineAlias "$base.but21" "Button25" vTcl:WidgetProc "busqueda" 1
    vTcl:DefineAlias "$base.but22" "Button26" vTcl:WidgetProc "busqueda" 1
    vTcl:DefineAlias "$base.ent29" "Entry17" vTcl:WidgetProc "busqueda" 1
    vTcl:DefineAlias "$base.ent33" "Entry18" vTcl:WidgetProc "busqueda" 1
    vTcl:DefineAlias "$base.lab21" "Label28" vTcl:WidgetProc "busqueda" 1

    ###################
    # CREATING WIDGETS
    ###################
    if {!$container} {
    vTcl:toplevel $base -class Toplevel \
        -background #d8d0c8 
    wm withdraw $base
    wm focusmodel $base passive
    wm geometry $base 202x117+290+37; update
    wm maxsize $base 1009 738
    wm minsize $base 106 2
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm title $base "Buscar"
    vTcl:FireEvent $base <<Create>>
    }
    entry $base.ent29 \
        -background white -textvariable searchstr -width 151 
    button $base.but21 \
        -command {BuscarTexto $searchstr} -height 0 -text Buscar -width 0 
    button $base.but22 \
        -command {set alarma ""
Window hide $widget(busqueda)} -height 0 \
        -text Cerrar -width 0 
    entry $base.ent33 \
        -background #d8d0c8 -foreground #f00000 -highlightbackground #d8d0c8 \
        -relief flat -selectforeground #f5010a -state disabled \
        -textvariable alarma -width 148 
    label $base.lab21 \
        -font {Helvetica -11} -height 0 -relief ridge \
        -text {Introduce el texto a buscar} -width 0 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.ent29 \
        -x 24 -y 39 -width 153 -height 22 -anchor nw -bordermode ignore 
    place $base.but21 \
        -x 26 -y 83 -width 50 -height 16 -anchor nw -bordermode ignore 
    place $base.but22 \
        -x 126 -y 82 -width 50 -height 16 -anchor nw -bordermode ignore 
    place $base.ent33 \
        -x 22 -y 66 -width 148 -height 12 -anchor nw -bordermode ignore 
    place $base.lab21 \
        -x 26 -y 12 -width 135 -height 18 -anchor nw -bordermode ignore 

    vTcl:FireEvent $base <<Ready>>
}

proc vTclWindow.top29 {base {container 0}} {
    if {$base == ""} {
        set base .top29
    }
    if {[winfo exists $base] && (!$container)} {
        wm deiconify $base; return
    }

    global widget
    vTcl:DefineAlias "$base" "reemplazo" vTcl:Toplevel:WidgetProc "" 1
    vTcl:DefineAlias "$base.but21" "Button30" vTcl:WidgetProc "reemplazo" 1
    vTcl:DefineAlias "$base.but24" "Button29" vTcl:WidgetProc "reemplazo" 1
    vTcl:DefineAlias "$base.but32" "Button28" vTcl:WidgetProc "reemplazo" 1
    vTcl:DefineAlias "$base.ent22" "Entry19" vTcl:WidgetProc "reemplazo" 1
    vTcl:DefineAlias "$base.ent23" "Entry20" vTcl:WidgetProc "reemplazo" 1
    vTcl:DefineAlias "$base.ent26" "Entry21" vTcl:WidgetProc "reemplazo" 1
    vTcl:DefineAlias "$base.lab21" "Label29" vTcl:WidgetProc "reemplazo" 1
    vTcl:DefineAlias "$base.lab30" "Label27" vTcl:WidgetProc "reemplazo" 1

    ###################
    # CREATING WIDGETS
    ###################
    if {!$container} {
    vTcl:toplevel $base -class Toplevel \
        -menu "$base.m25" 
    wm withdraw $base
    wm focusmodel $base passive
    wm geometry $base 202x126+290+61; update
    wm maxsize $base 1009 738
    wm minsize $base 106 2
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm title $base "Reemplazar"
    vTcl:FireEvent $base <<Create>>
    }
    label $base.lab30 \
        -font {Helvetica -11} -relief ridge -text {Texto a buscar...} \
        -width 0 
    button $base.but32 \
        -command {set alarma ""
Window hide $widget(reemplazo)} -height 16 \
        -text Cerrar -width 45 
    label $base.lab21 \
        -font {Helvetica -11} -relief ridge -text {Reemplazar por ...} \
        -width 0 
    entry $base.ent22 \
        -background white -textvariable searchstr 
    entry $base.ent23 \
        -background white -textvariable replacestr 
    menu $base.m25 \
        -tearoff 1 
    entry $base.ent26 \
        -background #d8d0c8 -foreground #0800c4 -relief flat \
        -textvariable alarma -width 123 
    button $base.but24 \
        -command {ReemplazarTexto $searchstr $replacestr} -height 16 \
        -text Reemplazar -width 72 
    button $base.but21 \
        \
        -command {ReemplazarTexto $searchstr $replacestr
while { $spos != "0.0" } {
ReemplazarTexto $searchstr $replacestr
}

set alarma "Operacion terminada"} \
        -height 16 -text Todo -width 43 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.lab30 \
        -x 11 -y 4 -width 87 -height 18 -anchor nw -bordermode ignore 
    place $base.but32 \
        -x 142 -y 103 -width 45 -height 16 -anchor nw -bordermode ignore 
    place $base.lab21 \
        -x 12 -y 46 -width 94 -height 18 -anchor nw -bordermode ignore 
    place $base.ent22 \
        -x 10 -y 24 -width 148 -height 22 -anchor nw -bordermode ignore 
    place $base.ent23 \
        -x 11 -y 65 -width 148 -height 22 -anchor nw -bordermode ignore 
    place $base.ent26 \
        -x 36 -y 86 -width 123 -height 17 -anchor nw -bordermode ignore 
    place $base.but24 \
        -x 14 -y 103 -width 77 -height 16 -anchor nw -bordermode ignore 
    place $base.but21 \
        -x 94 -y 103 -width 45 -height 16 -anchor nw -bordermode ignore 

    vTcl:FireEvent $base <<Ready>>
}

proc vTclWindow.top30 {base {container 0}} {
    if {$base == ""} {
        set base .top30
    }
    if {[winfo exists $base] && (!$container)} {
        wm deiconify $base; return
    }

    global widget
    vTcl:DefineAlias "$base" "impresion" vTcl:Toplevel:WidgetProc "" 1
    vTcl:DefineAlias "$base.but32" "Button31" vTcl:WidgetProc "impresion" 1
    vTcl:DefineAlias "$base.but33" "Button32" vTcl:WidgetProc "impresion" 1
    vTcl:DefineAlias "$base.ent31" "Entry22" vTcl:WidgetProc "impresion" 1
    vTcl:DefineAlias "$base.ent35" "Entry23" vTcl:WidgetProc "impresion" 1
    vTcl:DefineAlias "$base.lab34" "Label30" vTcl:WidgetProc "impresion" 1
    vTcl:DefineAlias "$base.lab36" "Label31" vTcl:WidgetProc "impresion" 1

    ###################
    # CREATING WIDGETS
    ###################
    if {!$container} {
    vTcl:toplevel $base -class Toplevel
    wm withdraw $base
    wm focusmodel $base passive
    wm geometry $base 184x153+10+67; update
    wm maxsize $base 1009 738
    wm minsize $base 106 2
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm title $base "Impresion"
    vTcl:FireEvent $base <<Create>>
    }
    entry $base.ent31 \
        -background white -textvariable printcom 
    button $base.but32 \
        \
        -command {global tmp

#Crea un archivo temporal ...
set n [open $tmp w]
puts $n [$widget(areatexto) get 1.0 end]
close $n


#Imprimelo y borralo
eval exec $printcom $printopt $tmp

file delete $tmp

Window hide $widget(impresion)} \
        -height 0 -text Imprimir -width 0 
    button $base.but33 \
        -command {Window hide $widget(impresion)} -height 0 -text Cancelar \
        -width 0 
    label $base.lab34 \
        -font {Helvetica -11} -height 0 -relief ridge \
        -text {Comando de impresion} -width 113 
    entry $base.ent35 \
        -background white -textvariable printopt 
    label $base.lab36 \
        -font {Helvetica -11} -height 0 -relief ridge \
        -text {Opciones de impresion} -width 111 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.ent31 \
        -x 18 -y 35 -width 148 -height 22 -anchor nw -bordermode ignore 
    place $base.but32 \
        -x 21 -y 121 -width 56 -height 16 -anchor nw -bordermode ignore 
    place $base.but33 \
        -x 106 -y 121 -width 56 -height 16 -anchor nw -bordermode ignore 
    place $base.lab34 \
        -x 18 -y 10 -width 113 -height 18 -anchor nw -bordermode ignore 
    place $base.ent35 \
        -x 18 -y 91 -width 148 -height 22 -anchor nw -bordermode ignore 
    place $base.lab36 \
        -x 18 -y 68 -width 113 -height 18 -anchor nw -bordermode ignore 

    vTcl:FireEvent $base <<Ready>>
}

proc vTclWindow.top32 {base {container 0}} {
    if {$base == ""} {
        set base .top32
    }
    if {[winfo exists $base] && (!$container)} {
        wm deiconify $base; return
    }

    global widget
    vTcl:DefineAlias "$base.che21" "Checkbutton1" vTcl:WidgetProc "$base" 1
    vTcl:DefineAlias "$base.men21" "Menubutton5" vTcl:WidgetProc "$base" 1
    vTcl:DefineAlias "$base.men21.m" "Menu1" vTcl:WidgetProc "$base" 1
    vTcl:DefineAlias "$base.men22" "Menubutton6" vTcl:WidgetProc "$base" 1
    vTcl:DefineAlias "$base.men22.m" "Menu2" vTcl:WidgetProc "$base" 1
    vTcl:DefineAlias "$base.men23" "Menubutton7" vTcl:WidgetProc "$base" 1
    vTcl:DefineAlias "$base.men23.m" "Menu3" vTcl:WidgetProc "$base" 1
    vTcl:DefineAlias "$base.men33" "menu_archivo" vTcl:WidgetProc "$base" 1
    vTcl:DefineAlias "$base.scr23" "Scrollbar1" vTcl:WidgetProc "$base" 1
    vTcl:DefineAlias "$base.scr24" "Scrollbar2" vTcl:WidgetProc "$base" 1
    vTcl:DefineAlias "$base.tex22" "areatexto" vTcl:WidgetProc "$base" 1

    ###################
    # CREATING WIDGETS
    ###################
    if {!$container} {
    vTcl:toplevel $base -class Toplevel \
        -background #c0c0c0 -menu "$base.m24" 
    wm focusmodel $base passive
    wm geometry $base 505x541+3+12; update
    wm maxsize $base 505 543
    wm minsize $base 108 2
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "ALIZEE 0.9 - Raza Mexicana Hackers Team"
    bindtags $base "$base Toplevel all menubindings"
    vTcl:FireEvent $base <<Create>>
    }
    menubutton $base.men33 \
        -activebackground #c0c0c0 -background #c0c0c0 -height 0 \
        -menu "$base.men33.m" -padx 5 -pady 4 -text Archivo -underline 0 \
        -width 0 
    menu $base.men33.m \
        -activeborderwidth 1 -borderwidth 1 
    $base.men33.m add command \
        -accelerator {} -command NuevoArchivo -image {} -label Nuevo 
    $base.men33.m add command \
        -accelerator {} -command {NuevoArchivo;AbrirArchivo} -image {} \
        -label Abrir... 
    $base.men33.m add command \
        -accelerator {} -command GuardarArchivo -image {} -label Guardar 
    $base.men33.m add command \
        -accelerator {} -command GuardarCArchivo -image {} \
        -label {Guardar como...} 
    $base.men33.m add separator
    $base.men33.m add command \
        -accelerator {} \
        -command {global printcom printopt
Window show $widget(impresion)} \
        -image {} -label Imprimir 
    $base.men33.m add separator
    $base.men33.m add command \
        -accelerator {} -command Salir -image {} -label Salir 
    menu $base.m24 \
        -activeborderwidth 1 -borderwidth 1 -cursor {} 
    text $base.tex22 \
        -background #ffffff -font [vTcl:font:get_font "vTcl:font10"] \
        -height 503 -width 486 -wrap word -xscrollcommand "$base.scr23 set" \
        -yscrollcommand "$base.scr24 set" 
    scrollbar $base.scr23 \
        -orient horizontal -width 489 
    scrollbar $base.scr24 \
        -command "$base.tex22 yview" -width 10 
    checkbutton $base.che21 \
        -activebackground #c0c0c0 -background #c0c0c0 \
        -command {#El valor de activacion del tablero de utilerias
#es 0 (cero), no 1 (uno)

if { $utilstate=="0" } {
    Window show $widget(utilerias)
    } else {
    Window hide $widget(utilerias)
}} \
        -height 27 -highlightbackground #c0c0c0 -offvalue 1 -onvalue 0 \
        -state normal -text Utilerias -variable utilstate -width 68 
    menubutton $base.men21 \
        -activebackground #c0c0c0 -background #c0c0c0 -height 0 \
        -menu "$base.men21.m" -padx 5 -pady 4 -text Editar -underline 0 \
        -width 0 
    menu $base.men21.m \
        -activeborderwidth 1 -borderwidth 1 
    $base.men21.m add command \
        -accelerator Ctrl+x -command {tk_textCut $widget(areatexto)} \
        -image {} -label Cortar 
    $base.men21.m add command \
        -accelerator Ctrl+c -command {tk_textCopy $widget(areatexto)} \
        -image {} -label Copiar 
    $base.men21.m add command \
        -accelerator Ctrl+y -command {tk_textPaste $widget(areatexto)} \
        -image {} -label Pegar 
    $base.men21.m add command \
        -accelerator Del \
        -command {#Al no conocer, en mi ignorancia, una
#manera mas sencilla de simplemente
#borrar texto seleccionado, se llevan a#cabo estos pasos

#Respaldar el contenido del clipboard
#Atrapando el error si esta vacio
if [catch {selection get -selection CLIPBOARD}] {
    tk_textCut $widget(areatexto)
    clipboard clear
    } else {
#Continuando si no lo esta
#
    set cbak [selection get -selection CLIPBOARD]

#Guardar la seleccion en el clipboard
#
    tk_textCut $widget(areatexto)

#Borrar el contenido en el clipboard
#
    clipboard clear

#Restaurar el contenido original 
#del clipboard
    clipboard append $cbak
}} \
        -image {} -label Borrar 
    $base.men21.m add command \
        -accelerator {} -command {# Borrar portapapeles
#
clipboard clear} \
        -image {} -label {Borrar PP} 
    $base.men21.m add separator
    $base.men21.m add command \
        -accelerator Ctrl+/ -command {$widget(areatexto) tag add sel 1.0 end} \
        -image {} -label {Selec. Todo} 
    $base.men21.m add command \
        -accelerator {} \
        -command {set poop [clock format [clock seconds]]

#Respaldar el contenido del clipboard
#Atrapa el error en caso de que este
#vacio
#
if [catch {selection get -selection CLIPBOARD}] {
    clipboard append $poop
    tk_textPaste $widget(areatexto)
    clipboard clear
    } else {
#Continuar normalmente si no lo esta
    set cbak [selection get -selection CLIPBOARD]

#Reemplazarlo con la hora y fecha
    clipboard clear
    clipboard append $poop

#Desplegar hora y fecha
    tk_textPaste $widget(areatexto)

#Restaurar el contenido original del
#clipboard
    clipboard clear
    clipboard append $cbak
}} \
        -image {} -label Hora/Fecha 
    $base.men21.m add separator
    $base.men21.m add checkbutton \
        -offvalue none -onvalue word -variable rauto -accelerator {} \
        -command {global rauto

if [expr [string compare $rauto word] == 0] {
    set rauto word
} else {
    set rauto none
}

$widget(areatexto) configure -wrap $rauto} \
        -image {} -label {Ret. Automatico} 
    menubutton $base.men23 \
        -activebackground #c0c0c0 -background #c0c0c0 -height 0 \
        -menu "$base.men23.m" -padx 5 -pady 4 -text Ayuda -underline 1 \
        -width 0 
    menu $base.men23.m \
        -activeborderwidth 1 -borderwidth 1 
    $base.men23.m add command \
        -accelerator {} -command ProcAyuda -image {} -label Ayuda 
    $base.men23.m add separator
    $base.men23.m add command \
        -accelerator {} -command {Window show $widget(acerca_de)} -image {} \
        -label {Acerca de ...} 
    menubutton $base.men22 \
        -activebackground #c0c0c0 -background #c0c0c0 -height 0 \
        -menu "$base.men22.m" -padx 5 -pady 4 -text Buscar -underline 0 \
        -width 0 
    menu $base.men22.m \
        -activeborderwidth 1 -borderwidth 1 
    $base.men22.m add command \
        -accelerator {} \
        -command {set spos "0.0"
Window show $widget(busqueda)} -image {} \
        -label Encontrar 
    $base.men22.m add command \
        -accelerator {} \
        -command {set spos "0.0"
Window show $widget(reemplazo)} -image {} \
        -label Reemplazar 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.men33 \
        -x 5 -y 1 -width 59 -height 23 -anchor nw -bordermode ignore 
    place $base.tex22 \
        -x 0 -y 25 -width 486 -height 503 -anchor nw -bordermode ignore 
    place $base.scr23 \
        -x 1 -y 528 -width 489 -height 13 -anchor nw -bordermode ignore 
    place $base.scr24 \
        -x 489 -y 24 -width 13 -height 504 -anchor nw -bordermode ignore 
    place $base.che21 \
        -x 421 -y 1 -width 68 -height 23 -anchor nw -bordermode ignore 
    place $base.men21 \
        -x 68 -y 1 -width 49 -height 23 -anchor nw -bordermode ignore 
    place $base.men23 \
        -x 180 -y 1 -width 51 -height 23 -anchor nw -bordermode ignore 
    place $base.men22 \
        -x 120 -y 1 -width 56 -height 23 -anchor nw -bordermode ignore 

    vTcl:FireEvent $base <<Ready>>
}

proc vTclWindow.top33 {base {container 0}} {
    if {$base == ""} {
        set base .top33
    }
    if {[winfo exists $base] && (!$container)} {
        wm deiconify $base; return
    }

    global widget
    vTcl:DefineAlias "$base" "ventenc" vTcl:Toplevel:WidgetProc "" 1
    vTcl:DefineAlias "$base.but21" "Button23" vTcl:WidgetProc "ventenc" 1
    vTcl:DefineAlias "$base.but36" "Button22" vTcl:WidgetProc "ventenc" 1
    vTcl:DefineAlias "$base.ent23" "Entry16" vTcl:WidgetProc "ventenc" 1
    vTcl:DefineAlias "$base.ent35" "Entry15" vTcl:WidgetProc "ventenc" 1
    vTcl:DefineAlias "$base.lab22" "Label26" vTcl:WidgetProc "ventenc" 1
    vTcl:DefineAlias "$base.lab34" "Label23" vTcl:WidgetProc "ventenc" 1

    ###################
    # CREATING WIDGETS
    ###################
    if {!$container} {
    vTcl:toplevel $base -class Toplevel
    wm withdraw $base
    wm focusmodel $base passive
    wm geometry $base 202x117+149+289; update
    wm maxsize $base 1009 738
    wm minsize $base 106 2
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm title $base "Encripcion"
    vTcl:FireEvent $base <<Create>>
    }
    label $base.lab34 \
        -font {Helvetica -11} -height 0 -relief ridge \
        -text {Introduce la clave de encripcion} -width 149 
    entry $base.ent35 \
        -background white -textvariable clave -width 153 
    button $base.but36 \
        \
        -command {global widget cbak clave


set clave ""

#tk_textPaste $widget(areatexto)


# Restaurar clipboard si es necesario
clipboard clear
if [info exists cbak] {
    clipboard append $cbak
}

Window hide $widget(ventenc)} \
        -height 21 -text Cerrar -width 62 
    button $base.but21 \
        \
        -command {global widget cbak accion

tk_textCut $widget(areatexto)

clipboard clear


if { $accion == "Encripcion" } {
    clipboard append [encrypt $sel $clave]
} else {
    clipboard append [decrypt $sel $clave]
}
    

tk_textPaste $widget(areatexto)


# Restaurar clipboard si es necesario
clipboard clear
if [info exists cbak] {
    clipboard append $cbak
}

set clave ""

Window hide $widget(ventenc)} \
        -height 16 -text Continuar -width 65 
    entry $base.ent23 \
        -background #d8d0c8 -font {Helvetica -11} -foreground #0a8e00 \
        -relief flat -state disabled -textvariable accion -width 68 
    label $base.lab22 \
        -font {Helvetica -11} -height 0 -text Proceso: -width 51 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.lab34 \
        -x 26 -y 30 -width 158 -height 18 -anchor nw -bordermode ignore 
    place $base.ent35 \
        -x 25 -y 55 -width 152 -height 22 -anchor nw -bordermode ignore 
    place $base.but36 \
        -x 113 -y 82 -width 64 -height 16 -anchor nw -bordermode ignore 
    place $base.but21 \
        -x 24 -y 82 -width 62 -height 16 -anchor nw -bordermode ignore 
    place $base.ent23 \
        -x 75 -y 6 -width 75 -height 22 -anchor nw -bordermode ignore 
    place $base.lab22 \
        -x 22 -y 8 -width 51 -height 18 -anchor nw -bordermode ignore 

    vTcl:FireEvent $base <<Ready>>
}

bind "menubindings" <Key-Control_L>a {
    AbrirArchivo
}
bind "selectall" <Key-Control_L>/ {
    # TODO: your event handler here
$widget(areatexto) tag add sel 1.0 end
}
bind "buscar" <Key-Control_L>f {
    set spos "0.0"
Window show $widget(busqueda)
}
bind "pastetext" <Key-Control_L>v {
    tk_textPaste $widget(areatexto)
}

Window show .
Window show .top21
Window show .top22
Window show .top23
Window show .top24
Window show .top25
Window show .top26
Window show .top27
Window show .top28
Window show .top29
Window show .top30
Window show .top32
Window show .top33

main $argc $argv
